Get all External IP Address Ranges

Cortex XSIAM Platform APIs

post /public_api/v1/assets/get_external_ip_address_ranges

Get a list of all your Internet exposure filtered by business units and organization handles.

The maximum result limit is 1000 ranges.

Note: You can send a request to retrieve either all or filtered results.

Required license: Cortex XSIAM Premium or Cortex XSIAM Enterprise Plus. In Cortex XSIAM Enterprise and Cortex NG SIEM, requires the ASM add-on.

Request headers
Authorization String required

{api_key}

Example: authorization_example
x-xdr-auth-id String required

{api_key_id}

Example: xXdrAuthId_example
CLIENT REQUEST
curl -X 'POST'
-H 'Accept: application/json'
-H 'Content-Type: application/json'
-H 'Authorization: authorization_example' -H 'x-xdr-auth-id: xXdrAuthId_example'
'https://api-yourfqdn/public_api/v1/assets/get_external_ip_address_ranges'
-d ''
import http.client conn = http.client.HTTPSConnection("api-yourfqdn") payload = "{\"request_data\":{\"filters\":[{\"field\":\"business_units\",\"operator\":\"contains\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":1000,\"sort\":{\"field\":\"Id\",\"keyword\":\"ASC\"}}}" headers = { 'Authorization': "SOME_STRING_VALUE", 'x-xdr-auth-id': "SOME_STRING_VALUE", 'content-type': "application/json" } conn.request("POST", "/public_api/v1/assets/get_external_ip_address_ranges", payload, headers) res = conn.getresponse() data = res.read() print(data.decode("utf-8"))
require 'uri' require 'net/http' require 'openssl' url = URI("https://api-yourfqdn/public_api/v1/assets/get_external_ip_address_ranges") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true http.verify_mode = OpenSSL::SSL::VERIFY_NONE request = Net::HTTP::Post.new(url) request["Authorization"] = 'SOME_STRING_VALUE' request["x-xdr-auth-id"] = 'SOME_STRING_VALUE' request["content-type"] = 'application/json' request.body = "{\"request_data\":{\"filters\":[{\"field\":\"business_units\",\"operator\":\"contains\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":1000,\"sort\":{\"field\":\"Id\",\"keyword\":\"ASC\"}}}" response = http.request(request) puts response.read_body
const data = JSON.stringify({ "request_data": { "filters": [ { "field": "business_units", "operator": "contains", "value": "string" } ], "search_from": 0, "search_to": 1000, "sort": { "field": "Id", "keyword": "ASC" } } }); const xhr = new XMLHttpRequest(); xhr.withCredentials = true; xhr.addEventListener("readystatechange", function () { if (this.readyState === this.DONE) { console.log(this.responseText); } }); xhr.open("POST", "https://api-yourfqdn/public_api/v1/assets/get_external_ip_address_ranges"); xhr.setRequestHeader("Authorization", "SOME_STRING_VALUE"); xhr.setRequestHeader("x-xdr-auth-id", "SOME_STRING_VALUE"); xhr.setRequestHeader("content-type", "application/json"); xhr.send(data);
HttpResponse<String> response = Unirest.post("https://api-yourfqdn/public_api/v1/assets/get_external_ip_address_ranges") .header("Authorization", "SOME_STRING_VALUE") .header("x-xdr-auth-id", "SOME_STRING_VALUE") .header("content-type", "application/json") .body("{\"request_data\":{\"filters\":[{\"field\":\"business_units\",\"operator\":\"contains\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":1000,\"sort\":{\"field\":\"Id\",\"keyword\":\"ASC\"}}}") .asString();
import Foundation let headers = [ "Authorization": "SOME_STRING_VALUE", "x-xdr-auth-id": "SOME_STRING_VALUE", "content-type": "application/json" ] let parameters = ["request_data": [ "filters": [ [ "field": "business_units", "operator": "contains", "value": "string" ] ], "search_from": 0, "search_to": 1000, "sort": [ "field": "Id", "keyword": "ASC" ] ]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api-yourfqdn/public_api/v1/assets/get_external_ip_address_ranges")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume()
<?php $curl = curl_init(); curl_setopt_array($curl, [ CURLOPT_URL => "https://api-yourfqdn/public_api/v1/assets/get_external_ip_address_ranges", CURLOPT_RETURNTRANSFER => true, CURLOPT_ENCODING => "", CURLOPT_MAXREDIRS => 10, CURLOPT_TIMEOUT => 30, CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_POSTFIELDS => "{\"request_data\":{\"filters\":[{\"field\":\"business_units\",\"operator\":\"contains\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":1000,\"sort\":{\"field\":\"Id\",\"keyword\":\"ASC\"}}}", CURLOPT_HTTPHEADER => [ "Authorization: SOME_STRING_VALUE", "content-type: application/json", "x-xdr-auth-id: SOME_STRING_VALUE" ], ]); $response = curl_exec($curl); $err = curl_error($curl); curl_close($curl); if ($err) { echo "cURL Error #:" . $err; } else { echo $response; }
CURL *hnd = curl_easy_init(); curl_easy_setopt(hnd, CURLOPT_CUSTOMREQUEST, "POST"); curl_easy_setopt(hnd, CURLOPT_URL, "https://api-yourfqdn/public_api/v1/assets/get_external_ip_address_ranges"); struct curl_slist *headers = NULL; headers = curl_slist_append(headers, "Authorization: SOME_STRING_VALUE"); headers = curl_slist_append(headers, "x-xdr-auth-id: SOME_STRING_VALUE"); headers = curl_slist_append(headers, "content-type: application/json"); curl_easy_setopt(hnd, CURLOPT_HTTPHEADER, headers); curl_easy_setopt(hnd, CURLOPT_POSTFIELDS, "{\"request_data\":{\"filters\":[{\"field\":\"business_units\",\"operator\":\"contains\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":1000,\"sort\":{\"field\":\"Id\",\"keyword\":\"ASC\"}}}"); CURLcode ret = curl_easy_perform(hnd);
var client = new RestClient("https://api-yourfqdn/public_api/v1/assets/get_external_ip_address_ranges"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "SOME_STRING_VALUE"); request.AddHeader("x-xdr-auth-id", "SOME_STRING_VALUE"); request.AddHeader("content-type", "application/json"); request.AddParameter("application/json", "{\"request_data\":{\"filters\":[{\"field\":\"business_units\",\"operator\":\"contains\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":1000,\"sort\":{\"field\":\"Id\",\"keyword\":\"ASC\"}}}", ParameterType.RequestBody); IRestResponse response = client.Execute(request);
Body parameters
application/json
request_dataobject

A dictionary containing the API request fields.

An empty dictionary returns all results.

filtersarray

Array of filter fields.

[
fieldstring (Enum)required

Identifies the external IP ranges field the filter is matching.

Allowed values:"business_units""organization_handles"
operatorstring (Enum)required

Identifies the comparison operator you want to use for this filter.

Allowed values:"contains""not_contains"
valuestringrequired

Value that this filter must match.

]
search_frominteger

Represents the start offset index of results.

search_tointeger

Represents the end offset index of results.

Default:1000
sortobject

Identifies the sort order for the result set.

fieldstring (Enum)required

Identifies the field you want to sort by. Case-sensitive.

Default:"first_ip"
Allowed values:"Id""first_ip""last_ip"
keywordstring (Enum)required

Whether you want to sort in ascending (ASC) or descending (DESC) order. Case-sensitive.

Default:"DESC"
Allowed values:"ASC""DESC"
REQUEST
{ "request_data": { "filters": [ { "field": "organization_handles", "operator": "contains", "value": "irt" } ], "search_from": 0, "search_to": 500 } }
Responses

OK

Body
application/json
replyobject
total_countinteger

The total number of possible results, value is limited to 9,999. Note: total_count value is limited. If the filter returns 10,000 results or more, the value will be 9,999, but you still can use paging until the data is finished.

result_countinteger

The number of external IP ranges actually returned as result.

external_ip_address_rangesarray

A list of external IP address ranges (list). Each IP address range is JSON.

[
range_idstring
first_ipstring
last_ipstring
ips_countinteger
active_responsive_ips_countinteger
date_addedinteger
business_unitsarray[string]
organization_handlesarray[string]
]
RESPONSE
{ "reply": { "total_count": 2, "result_count": 2, "external_ip_address_ranges": [ { "range_id": "<range_id>", "first_ip": "<ip_address>", "last_ip": "<ip_address>", "ips_count": 8, "active_responsive_ips_count": 0, "date_added": 1649644918955, "business_units": [ "Test - Acme Supply" ], "organization_handles": [ "MAINT-YY", "IRT-PCCW", "BNA2-YY", "AP-AP", "TA-AP" ] }, { "range_id": "<range_id>", "first_ip": "<ip_address>", "last_ip": "<ip_address>", "ips_count": 32768, "active_responsive_ips_count": 0, "date_added": 1649644918955, "business_units": [ "Test - Acme Supply" ], "organization_handles": [ "IA-AP", "IRT-P", "AP-AP", "MAINT-HK", "NIC-HM", "ORG-AP" ] } ] } }

Bad Request. Got an invalid JSON.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }

Unauthorized access. An issue occurred during authentication. This can indicate an incorrect key, id, or other invalid authentication parameters.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }

Unauthorized access. User does not have the required license type to run this API.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }

Forbidden access. The provided API Key does not have the required RBAC permissions to run this API.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }

Internal server error. A unified status for API communication type errors.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }